# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%bcond_without repolib

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define namedversion %{version}

%define section free

Name:           sisu2
Version:        2.2.1
Release:        1%{?dist}
Epoch:          0
Summary:        Sisu 2.
License:        ASL 2.0
URL:            http://sonatype.org
Group:          Development/Libraries/Java
# git clone git://github.com/sonatype/sisu.git && cd sisu && git archive sisu-2.2.1 > ../sisu2-2.2.1.tar && bzip2 ../sisu2-2.2.1.tar
Source0:        sisu2-2.2.1.tar.bz2
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         sisu2-pom.patch
Patch1:         sisu2-inject-registries-pom.patch
Patch2:         sisu2-inject-bean-pom.patch
BuildRequires:  jpackage-utils
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  aopalliance
BuildRequires:  apache-commons-parent
BuildRequires:  apache-felix-framework
BuildRequires:  apache-felix-main
BuildRequires:  apache-felix-shell
BuildRequires:  forge-parent >= 0:5
BuildRequires:  logback
BuildRequires:  maven-bundle-plugin
BuildRequires:  maven-enforcer-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-shade
BuildRequires:  oss-parent
BuildRequires:  plexus-containers-component-annotations >= 0:1.5.5
BuildRequires:  sisu-guice >= 0:2.1.7
BuildRequires:  slf4j
BuildRequires:  testng
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:  jpackage-utils
Requires:  java >= 0:1.6.0
Requires:  aopalliance
Requires:  apache-felix-framework
Requires:  apache-felix-main
Requires:  apache-felix-shell
Requires:  plexus-containers-component-annotations >= 0:1.5.5
Requires:  sisu-guice >= 0:2.1.7
Requires:  slf4j
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Sisu 2.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -c
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2

%build
MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp \
        -e \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -DaltDeploymentRepository=oss-releases::default::file://$(pwd)/maven2-brew \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.skip=true \
        deploy \
        javadoc:aggregate \

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}/%{name}

# jars
pushd sisu-inject
install -m 644 containers/guice-bean/guice-bean-binders/target/guice-bean-binders-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-bean/guice-bean-containers/target/guice-bean-containers-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-bean/guice-bean-converters/target/guice-bean-converters-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-bean/guice-bean-inject/target/guice-bean-inject-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-bean/guice-bean-locators/target/guice-bean-locators-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-bean/guice-bean-reflect/target/guice-bean-reflect-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-bean/guice-bean-scanners/target/guice-bean-scanners-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-bean/sisu-inject-bean/target/sisu-inject-bean-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-plexus/guice-plexus-binders/target/guice-plexus-binders-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-plexus/guice-plexus-converters/target/guice-plexus-converters-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-plexus/guice-plexus-locators/target/guice-plexus-locators-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-plexus/guice-plexus-metadata/target/guice-plexus-metadata-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-plexus/guice-plexus-scanners/target/guice-plexus-scanners-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-plexus/guice-plexus-shim/target/guice-plexus-shim-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 containers/guice-plexus/sisu-inject-plexus/target/sisu-inject-plexus-%{version}.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 registries/sisu-osgi-registry/target/sisu-osgi-registry-2.2.1.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 registries/sisu-spi-registry/target/sisu-spi-registry-2.2.1.jar %{buildroot}%{_javadir}/%{name}/

(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do ln -s ${jar} ${jar/-%{version}/}; done)

# poms
mkdir -p %{buildroot}%{_datadir}/maven2/poms

install -m 644 containers/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-containers.pom
install -m 644 registries/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-registries.pom
install -m 644 containers/guice-bean/guice-bean-binders/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-bean-binders.pom
install -m 644 containers/guice-bean/guice-bean-containers/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-bean-containers.pom
install -m 644 containers/guice-bean/guice-bean-converters/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-bean-converters.pom
install -m 644 containers/guice-bean/guice-bean-inject/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-bean-inject.pom
install -m 644 containers/guice-bean/guice-bean-locators/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-bean-locators.pom
install -m 644 containers/guice-bean/guice-bean-reflect/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-bean-reflect.pom
install -m 644 containers/guice-bean/guice-bean-scanners/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-bean-scanners.pom
install -m 644 containers/guice-bean/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-bean.pom
install -m 644 containers/guice-bean/sisu-inject-bean/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-sisu-inject-bean.pom
install -m 644 containers/guice-plexus/guice-plexus-binders/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-plexus-binders.pom
install -m 644 containers/guice-plexus/guice-plexus-converters/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-plexus-converters.pom
install -m 644 containers/guice-plexus/guice-plexus-locators/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-plexus-locators.pom
install -m 644 containers/guice-plexus/guice-plexus-metadata/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-plexus-metadata.pom
install -m 644 containers/guice-plexus/guice-plexus-scanners/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-plexus-scanners.pom
install -m 644 containers/guice-plexus/guice-plexus-shim/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-plexus-shim.pom
install -m 644 containers/guice-plexus/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-guice-plexus.pom
install -m 644 containers/guice-plexus/sisu-inject-plexus/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-sisu-inject-plexus.pom
install -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-sisu-inject.pom
install -m 644 registries/sisu-osgi-registry/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-sisu-osgi-registry.pom
install -m 644 registries/sisu-spi-registry/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-sisu-spi-registry.pom
popd
install -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-sisu-parent.pom

# depmaps
%add_to_maven_depmap org.sonatype.sisu.inject containers %{namedversion} JPP/%{name} containers
%add_to_maven_depmap org.sonatype.sisu.inject registries %{namedversion} JPP/%{name} registries
%add_to_maven_depmap org.sonatype.sisu.inject guice-bean %{namedversion} JPP/%{name} guice-bean
%add_to_maven_depmap org.sonatype.sisu.inject guice-bean-binders %{namedversion} JPP/%{name} guice-bean-binders
%add_to_maven_depmap org.sonatype.sisu.inject guice-bean-containers %{namedversion} JPP/%{name} guice-bean-containers
%add_to_maven_depmap org.sonatype.sisu.inject guice-bean-converters %{namedversion} JPP/%{name} guice-bean-converters
%add_to_maven_depmap org.sonatype.sisu.inject guice-bean-inject %{namedversion} JPP/%{name} guice-bean-inject
%add_to_maven_depmap org.sonatype.sisu.inject guice-bean-locators %{namedversion} JPP/%{name} guice-bean-locators
%add_to_maven_depmap org.sonatype.sisu.inject guice-bean-reflect %{namedversion} JPP/%{name} guice-bean-reflect
%add_to_maven_depmap org.sonatype.sisu.inject guice-bean-scanners %{namedversion} JPP/%{name} guice-bean-scanners
%add_to_maven_depmap org.sonatype.sisu.inject guice-plexus %{namedversion} JPP/%{name} guice-plexus
%add_to_maven_depmap org.sonatype.sisu.inject guice-plexus-binders %{namedversion} JPP/%{name} guice-plexus-binders
%add_to_maven_depmap org.sonatype.sisu.inject guice-plexus-converters %{namedversion} JPP/%{name} guice-plexus-converters
%add_to_maven_depmap org.sonatype.sisu.inject guice-plexus-locators %{namedversion} JPP/%{name} guice-plexus-locators
%add_to_maven_depmap org.sonatype.sisu.inject guice-plexus-metadata %{namedversion} JPP/%{name} guice-plexus-metadata
%add_to_maven_depmap org.sonatype.sisu.inject guice-plexus-scanners %{namedversion} JPP/%{name} guice-plexus-scanners
%add_to_maven_depmap org.sonatype.sisu.inject guice-plexus-shim %{namedversion} JPP/%{name} guice-plexus-shim
%add_to_maven_depmap org.sonatype.sisu sisu-inject %{namedversion} JPP/%{name} sisu-inject
%add_to_maven_depmap org.sonatype.sisu sisu-inject-bean %{namedversion} JPP/%{name} sisu-inject-bean
%add_to_maven_depmap org.sonatype.sisu sisu-inject-plexus %{namedversion} JPP/%{name} sisu-inject-plexus
%add_to_maven_depmap org.sonatype.sisu sisu-parent %{namedversion} JPP/%{name} sisu-parent
%add_to_maven_depmap org.sonatype.sisu sisu-osgi-registry %{namedversion} JPP/%{name} sisu-osgi-registry
%add_to_maven_depmap org.sonatype.sisu sisu-spi-registry %{namedversion} JPP/%{name} sisu-spi-registry


# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE-ASL.txt
%dir %{_javadir}*/%{name}
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*/
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Oct 20 2011 Ralph Apel <r.apel@r-apel.de> 0:2.2.1-1
- 2.2.1

* Sun Oct 16 2011 Ralph Apel <r.apel@r-apel.de> 0:2.2.0-1
- 2.2.0 as sisu2

* Thu Jan 06 2011 David Walluck <dwalluck@redhat.com> 0:1.4.3.2-1
- release
